
#include <pthread.h>
#include <assert.h>

typedef pthread_key_t TLSIndex;

inline void TLSSet( TLSIndex tls_index, void * value )
{
    pthread_setspecific( tls_index, value );
}

inline void * TLSGet( TLSIndex tls_index )
{
    return pthread_getspecific( tls_index );
}

inline TLSIndex TLSCreate()
{
    pthread_key_t
        key;
    int 
        result;
    
    result = pthread_key_create( &key, NULL );
    
    assert( result == 0 );
    
    return key;
}

inline void TLSDestroy( TLSIndex tls_index )
{
    pthread_key_delete( tls_index );
}